;--------------------------------------------------------
;     ந⥫   稯
; Manufacture , Device   ⠭
; ⠪ ⠭ ࠧ 稯  樨 ⥭

ShowId:
	mov cx,offset MTitleEnd-offset MTitle	;   ⠡ ந⥫
	mov si,offset MTitle

ShowIdBegin:
	lodsb
	dec cx
	cmp al,Manufacture	; ᮢ  ந⥫ ?
	je Continue01

	call NextManufacture
	jnc ShowIdBegin

	jmp UnKnowChip	; 稫 ᯨ᮪ ந⥫

Continue01:

	mov dx,si		; ந⥫ ।
	MOV AH,9
	int 21h

ShowDevice:
	mov al,Manufacture
        case Amd, ShowDeviceAMD
        case Winbond, ShowDeviceWinbond
        case Atmel, ShowDeviceAtmel
        case Intel, ShowDeviceIntel
        case SST, ShowDeviceSST
        case MX, ShowDeviceMX
        case Thomson, ShowDeviceThomson
        case MoselVitelic, ShowDeviceMoselVitelic
        case EON, ShowDeviceEon		; EON/Mitsubishi
        case ISSI, ShowDeviceISSI
        case Cypress, ShowDeviceCypress
        case National, ShowDeviceNational
        case NEC, ShowDeviceNec
        case Toshiba, ShowDeviceToshiba
        case ASI, ShowDeviceASI

ShowDeviceAMD:
	mov cx,offset AMDe-offset AMDb ;  ⠡ 稯
	mov si,offset AmdB
	jmp ShowDeviceBegin	;  ணࠬ ᪠  ᮢ饣  ⠭

ShowDeviceWinbond:
	mov cx,offset WinbondE-offset WinbondB 
	mov si,offset WinbondB
	jmp ShowDeviceBegin

ShowDeviceAtmel:
	mov cx,offset AtmelE-offset AtmelB
	mov si,offset AtmelB
	jmp ShowDeviceBegin

ShowDeviceIntel:
	mov cx,offset IntelE-offset IntelB
	mov si,offset IntelB
	jmp ShowDeviceBegin

ShowDeviceSST:
	mov cx,offset SSTe-offset SSTb
	mov si,offset SSTb
	jmp ShowDeviceBegin

ShowDeviceMX:
	mov cx,offset MXe-offset MXb
	mov si,offset MXb
	jmp ShowDeviceBegin

ShowDeviceThomson:
	mov cx,offset Thomsone-offset Thomsonb
	mov si,offset Thomsonb
	jmp ShowDeviceBegin

ShowDeviceMoselVitelic:
	mov cx,offset MoselVitelicE-offset MoselVitelicB
	mov si,offset MoselVitelicB
	jmp ShowDeviceBegin

ShowDeviceEON:
	mov cx,offset EonE-offset EONB  ; "   " (r)(c)
	mov si,offset EONB
	jmp ShowDeviceBegin

ShowDeviceISSI:
	mov cx,offset IssiE-offset IssiB  ;   ⠡ ன
	mov si,offset IssiB
	jmp ShowDeviceBegin

ShowDeviceCypress:
	mov cx,offset CypressE-offset CypressB  ;   ⠡ ன
	mov si,offset CypressB
	jmp ShowDeviceBegin

ShowDeviceNec:
	mov cx,offset NecE-offset NecB  ;   ⠡ ன
	mov si,offset NecB
	jmp ShowDeviceBegin

ShowDeviceNational:
	mov cx,offset NationalE-offset NationalB  ;   ⠡ ன
	mov si,offset NationalB
	jmp ShowDeviceBegin

ShowDeviceTOSHIBA:
	mov cx,offset ToshibaE-offset ToshibaB  ;   ⠡ ன
	mov si,offset ToshibaB
	jmp ShowDeviceBegin

ShowDeviceASI:
	mov cx,offset ASIE-offset ASIB  ;   ⠡ ன
	mov si,offset ASIB
	jmp ShowDeviceBegin



; ᮡ⢥  ⭮ 稯

ShowDeviceBegin:       
	lodsb
	
	cmp al,Device	; ᮢ  奬 ?

	je ShowDeviceOk

	call NextDevice
	jnc ShowDeviceBegin

	jmp UnknoWChip

ShowDeviceOk:

	mov di,Offset SizeChip
	movsw		; ⠭ ࠧ 稯
	movsw

	mov dx,si	; ᮢ   뢠  奬
	MOV AH,9
	int 21h
	clc

ret	; ᯥ譮 襭 

;---------------------------
NextDevice:
	lodsw
	lodsw
	sub cx,4
	jg NextDevice00
	stc
 	ret

NextDevice00:
	lodsb
	dec cx
	jnz NextDevice01
	stc
	ret

NextDevice01:

	cmp al,'$'	; 稫 ᠭ ।饣 稯
	jne NextDevice00
	clc
ret	;   ᠭ 稯

;------------------------------------
UnKnowChip:
	DisplayString UnKnowChipMessage

;뢠  ⠭  FLASH
	mov al,Manufacture
	debug
	mov al,Device
	debug
	stc    ;  ᯥ譮 襭
ret 

;-----------------------------------------------------
; ணࠬ    ᫥饣    ந⥫
; ७ 襭 ந⥫   
;-----------------------------------------------------
NextManufacture:
	lodsb
	dec cx
	jz FailNextManufacture
	cmp al,'$'	; 稫 ᠭ ।饣 ந⥫?
	jne NextManufacture
	clc
	ret

FailNextManufacture:
	stc
	ret
;-----------------------------------------------------
UnKnowChipMessage db 10d,13d,"   ⥭ : $"

