;--------------------------------------------------------
ProcedureWrite:
; 1)    奬 
; 2) । ࠧ 
; 3) ࠥ ᫨ 㦭
; 4) 뢠  䠩  ஢

	call Ident	; 뢠 䨪 奬

	call OpenInFile	; 뢠 䠩
	jc EndWrite

	call TestSize		; ஢塞  稯   䠩
	jnc Write
	jmp EndWrite

WRITE:
	call EnableWork
	mov al,Manufacture	; ந⥫

	case Intel,wIntel
	case AMD,wAMD
	case Atmel,wAtmel
	case Winbond,wWinbond
	case MX,wMX
	case SST,wSST
	case MoselVitelic,wMosel
	case Thomson,wThomson
	case Eon,wEon
	case issi,wISSI

	displaystring AbortWrite

TestWrite:		;    楤   ஢ન
	jc EndWrite
	call Verify
EndWrite:
	call CloseFile
	call DisableWork
ret
;=========================================================
; 騥 楤
ReadPage:
	mov bx,HandlerIn
	mov cx,pSize
	mov dx,Offset Buffer
	mov ah,03Fh
	int 21h
	jnc ReadPage00	; ⠫  ᯥ譮
RPageFail:
	DisplayString ErrorReadPage
	jmp EndWork	; ਩ 襭

ReadPage00:
	cmp ax,pSize
	jne rPageFail ;  ⠭ ॡ㥬 ᫮ 
	clc
ret
	ErrorReadPage db 10d,13d,7,'訡 ⥭ 室 䠩$'
;---------------------------------------------------------
WritePage:	;  ࠭  page ⨯
	mov cx,pSize		; ࠧ ࠭
	mov si,offset Buffer	;   㤠 
	CLI		;   
WriteCyckle:
	lodsb
	mov dx,DataPort
	out dx,al
	call incrementA
	loop WriteCyckle
	STI		; ࠧ蠥 뢠
	call WaitToggle
ret
;---------------------------------------------------------
Verify:
	
	displayString VerifyOn
	mov bx,HandlerIn
	mov ah,42h
	mov al,00h
	xor cx,cx
	xor dx,dx
	int 21h		;  砫 䠩

	jnc Verify00
	displayString NotSetBegin
	stc
	jmp EndVerify

Verify00:
	call resetAdress
	mov di,offset SizeChip
	mov ax,[di+1]		; ࠧ 稯  256  
	mov pCounter,Ax

CyckleVerify:
	mov pSize,256d		; ࠧ 
	call ReadPage
	mov si,Offset Buffer

CyckleVerify00:
	mov dx,DataPort
	in al,dx
	cmp al,[si]	; ᮢ ᠭ  ⠭
	jne vFail

	call IncrementA ; 㢥稫  FLASH 
	inc si		; ᤢ㫨 㪠⥫  ࠧ FLASH
	dec pSize	;   ஢ਫ
	jnz CyckleVerify00
	dec pCounter	;   ஢ਫ
	jnz CyckleVerify

	displayString OK
	clc
	jmp EndVerify
vFail:
	displayString VerifyFail
	stc
EndVerify:
ret

VerifyFail db 10D,13D,'⠭  FLASH  ᮢ  䠩 !!!$'

;---------------------------------------------------------
TestSize:		; ஢塞  稯   䠩
	mov bx,HandlerIn
	mov ah,42h
	mov al,02h
	xor cx,cx
	xor dx,dx
	int 21h
	jc ErrorSeek

	mov di,offset SizeChip
	 cmp ax,[di]
	jne ErrorSizeFile
	 cmp dx,[di+2]
	jne ErrorSizeFile

	mov bx,HandlerIn
	mov ah,42h
	mov al,0h
	xor cx,cx
	xor dx,dx
	int 21h		;     
	
ret 

ErrorSizeFile:
	displayString ErrorSizeFileMessage
	stc
	ret
ErrorSeek:
	DisplayString ErrorSeekMessage
	stc
ret
;---------------------------------------------------------
UnlockJEDEC:	; ⨥ ஢     Atmel,SST,Winbond  

	OutPort HiHiPort,0h
	WriteAdress 5555h,0AAh
	WriteAdress 2AAAh,055h
	WriteAdress 5555h,080h
	WriteAdress 5555h,0AAh
	WriteAdress 2AAAh,055h
	WriteAdress 5555h,020h
	DisplayString WaitUnlockChip
	call Pause50MS
ret

;---------------------------------------------------------
;===============    ⤥  ============
; ᮡ⢥ 楤   ࠧ ந⥫

	Include 	.\inc\wIntel.inc
	Include 	.\inc\wAMD.inc
	Include 	.\inc\wAtmel.inc
	Include 	.\inc\wWinbond.inc
	Include 	.\inc\wMX.inc
	Include 	.\inc\wSST.inc
	Include 	.\inc\wMosel.inc
	Include 	.\inc\wThomson.inc
	Include 	.\inc\wEon.inc
	Include 	.\inc\wISSI.inc
;=========================================================

;=============== 㯯  ============

; 筠 楤   Winbond,Atmel,SST
wJEDEC:

	call UnLockJEDEC
	jc EndwJEDEC

	call ResetAdress

	displayString WriteOn
wJEDEC_:
	call ReadPage		;  䠩  

	call writePage
	 jc EndwJEDEC

	 dec pCounter
	  jnz wJEDEC_ 		;  ࠭ ᠭ ?
	jmp TestWrite		; ஢塞 ᠭ
EndwJedec:
ret
;----------------------------------------------------------------
NotSetBegin db 10d,13d,' 㤠 ⠭ 㪠⥫ 室 䠩  砫 !!!$'
VerifyOn db 10d,13d,' ஢ ᠭ $'
ErrorSizeFileMessage db 10d,13d,' 䠩  ᮮ⢥  稯$'
ErrorSeekMessage db 10d,13d,' 㤠   室 䠩$'
SuccWrite db 10D,13D,' ᠭ ᯥ譮$'
FailWrite db 10D,13D,'  ᠭ $'
AbortWrite db 10D,13D,'  ⪠.  $'
WaitUnlockChip db 10D,13D,'     $'
WriteOn db 10D,13D,'   $'
