;--------------------------------------------------------
; Handlerin 
; aPoint
; Manufacture 
; device                ந樠஢

wAtmel:
	mov al,device

	case 0D5h,wAt29C010
	case 0DAh,wAt29C020
	case 008h,wAt49F002NT
	case 017h,wAt49F010

	displayString AbortWrite

EndWAtmel:
	call CloseFile
	call DisableWork
ret
;===============    ⤥  ============
wAT29C010:
	mov pSize,128D		; AT29C010    128 
	mov pCounter,_1M/128d	; ꥬ 奬 / ࠧ 
	call wJedec
ret

;----------------------------------------------------------------
wAT29C020:
	mov pSize,256D		; AT29C020    256 
	mov pCounter,_2M/256d	; ꥬ 奬 / ࠧ 
	call wJedec
ret
;----------------------------------------------------------------
wAt49F010:
	mov Psize,256D
	mov pCounter,_1M/256d	;    256 
        jmp EntryFor49F010      ; 襬 筮 49F002
;----

wAt49F002NT:
	mov Psize,256D
	mov pCounter,_2M/256d	;    256 

EntryFor49F010:
	call resetAdress

	test byte3,01h
	jz notLockOutAT49F002

	DisplayString Block

notLockOutAT49F002:		;  BootBlock   ࠥ

;	call eJedec

;	mov bl,0ffh
;	call TestClearNew

	displayString WriteOn
	call ResetAdress

wAt49F002NT00:

	call ReadPage

	mov cx,pSize
	mov si,Offset Buffer

wAt49F002NT01:

	WriteAdress 05555h,0AAh
	WriteAdress 02AAAh,055h
	WriteAdress 05555h,0A0h	; ࠧ訫  
	
	OutPort loPort,AdressLo
	OutPort HiPort,AdressHi	; ⠭  

	lodsb
	outport DataPort,al	; ᫠ 
	call WaitToggle
	jc EndwAt49F002NT
	call IncrementA
	loop wAt49F002NT01

	 dec Pcounter
 	jnz wAt49F002NT00

	outport DataPort,0F0h	;   ० ⥭
	clc
	jmp TestWrite

EndwAt49F002NT:
	stc
ret
;----------------------------------------------------------------
block db 10D,13D,'BootBlock 饭.        ஢$'
